/*
 * BCV Color Match Application
 * http://www.bcv.ch
 *
 * Copyright 2014, Axio-Net Solutions Pvt. Ltd. India
 * All rights reserved under 
 * http://www.axionet.ch
 * date : 19-jun-14
 */
 
 
var	level = 1; 						//current level
var	turn = 0; 						//current turn
var	difficulty = 1; 				//user difficulty by default
var	score = 0; 						//current score
var	active = false; 				//whether a turn is active or not
var	handler = false; 				//whether the touchstart and sound handlers are active
var	shape = '.shape'; 				//cached string for the pad class
var	genSequence = []; 				//array containing the generated/randomized pads
var	plaSequence = []; 				//array containing the users pad selections
var time_count = 0; 				//collects time count
var gr_per = 0;
var game_end_flag = 1;
var tout;
 
var myVar = setInterval(function(){
	if(game_end_flag == 0)
		myTimer();
},1000); 													//Call Timer for each one second.

function myTimer() {
	var prog_add = time_count * 10;
	 $('.progress').progress({value: prog_add , color:'#00aeef', height: '5px'});
	time_count++;
		if(time_count > 10){
		incorrectSequence();
		//clearInterval(myVar);
	}
}

function init() {
 
 		time_count = 0;	
	    game_end_flag = 1;
		$('.score_text').text('0');
 		if(handler === false){										//checks to see if handlers are already active
		  initPadHandler();											//if not activate them			 	
		}
	    newGame();			
}

function initPadHandler(){
		$('.pd').bind('touchend',function(){			
			time_count = 0;											 //Reset timer when user is touchends
			if(active===true){
				start_flag = 1;
				var pad=parseInt($(this).data('pad'),10);
				flash($(this),1,300, pad); 
				logPlayerSequence(pad);
			}	 
		});
		handler=true;
}

function newGame(){														//resets the game and generates a starts a new level

		level = 1;
		score = 0;
		genSequence.length = 0; 										// added for Pascal changes 16-Apr-2014
		time_count = 0;	
		setTimeout(function(){
			newLevel();
		},2000);
}

function  newLevel(){

		plaSequence.length=0;
		pos=0;
		turn=0;
		flash_count=1;
		randomizePad(level); 					    	//randomize pad with the correct amount of numbers for this level
		time_count = 0;	
		if( level == 21) { 		                        //Increase difficulty. for each 20 level.
		difficulty = difficulty/1.25;
		}
		if( level == 41) {
		difficulty = difficulty/1.5;
		}
		if( level == 61) {
		difficulty = difficulty/2;
		}
		if( level > 100 ) {                            // To terminate game when user reaches 100 levels.
		incorrectSequence();
		return false;
		}
		
		displaySequence();   								//show the user the sequence
       	active=false;
		game_end_flag=0;
}

var flash_count = 1;

function flash(element, times, speed, pad){ 				//function to make the pads appear to flash
	
time_count = 0;
if((flash_count++)/2 == genSequence.length)					// get the sequence of flashes generated and check sequence displayed completely.
	active = true;
	
if(times > 0){				
 												             //make sure we are supposed to flash
	       playSound(pad);									 //play the corresponding pad sound
		/* element.stop().animate({opacity: '1'}, {		     //animate the element to appear to flash
				duration: 50,
				complete: function(){
				element.stop().animate({opacity: '0'}, 700); //CR6  @BCV Color Match Feedback_June 2 Delivery
				}
			});		*/
						
						//end animation
		/*	element.fadeTo(200,1); 	
	            setTimeout(	function() {
				element.fadeTo(200,0); 	  			
		    }, 300); */
			
			setTimeout( function() {
				   element.css("opacity","1");
			}, 0);

			setTimeout( function() {
				   element.css("opacity","0");
			}, speed-30); 	
							
		}
		
		if (times > 0) {									   //call the flash function again until done the correct amount of times 
			setTimeout(function () {
				flash(element, times, speed, pad);
			}, speed);
			times -= 1;										   //times - 1 for each time it's called
		} 
}
	
function randomizePad(passes){								    //generate random numbers and push them to the generated number array iterations determined by current level
	genSequence.push(Math.floor(Math.random() * 4) + 1);
   //$(".progress-container").text(":-"+ genSequence );			
}

function logPlayerSequence(pad){							    //log the player selected pad to user array and call the checker function
	plaSequence.push(pad);
	checkSequence(pad);		
}

function checkSequence(pad){						              //checker function to test if the pad the user pressed was next in the sequence
 
		if(pad !== genSequence[turn]){      		             //if not correct 
				incorrectSequence();
		}
		else{										//if correct
				keepScore();						//update the score
				turn++;				     			//incrememnt the turn
		}

		if(turn === genSequence.length){			//if completed the whole sequence	
			level++;								//increment level, display it, disable the pads wait 1 second and then reset the game
			score++;			
			$('.score_text').text(score); 
			active=false;
			setTimeout(function(){
				newLevel();
			},1000);
		}
}

function displaySequence(){								//display the generated sequence to the user

		$.each(genSequence, function(index, val) {		//iterate over each value in the generated array	
			setTimeout(function(){
			flash($(shape+val),1,300,val);
			},500*index*difficulty);					// multiply timeout by how many items in the array so that they play sequentially and multiply by the difficulty modifier
		});
}
 
function keepScore(){									//keep the score
		
		var multiplier = 0;

		switch(difficulty)								//choose points modifier based on difficulty
		{
			case '2':
				multiplier=1;
				break;
			
			case '1':
				multiplier=2;
				break;

			case '0.5':
				multiplier = 3;
				break;

			case '0.25':
				multiplier = 4;
				break;
		}
 		 
		//displayScore();									//display score on screen
}

function incorrectSequence(){      						//if user makes a mistake
	$(".new-game_btn").attr("src","images/new.png");
	$('.progress').progress({value: 0 , color:'#00aeef', height: '5px'});
	active = false;
	time_count = 0;
	game_end_flag = 1;
    start_flag = 1;
	difficulty = 1; 
	
   play_end();
    $(".share_result_error").html(" ");
	$(".caution .title").html("<span class='endmsg'> Jeu termin&eacute; !<span>"); //Popup Message : Game Over !
	$(".caution").css("cssText", "height: 10% !important;");
	    var height = $(window).height();
    	var width = $(window).width();

    if(width>height) {
    	if( width > 800 )
    		$(".caution .title").css("cssText", 'margin-top: 50px !important');

    	if( (800 >= width) && (640 <= width) ) {
    		$(".caution .title").css("cssText", "margin-top: 14px !important;");
    	}
    
    }
	$(".caution").popup();
 
   
 	// self_bestscore_check();
}

var scoredata = '{"BestScore":"true","Type":"1"}';
var json_data = "";

var t = '';
var start_flag = 1;

 
$(document).ready( function(){

	var height = $(window).height();
	var width = $(window).width();
 
		 //$("img.loading").css("display","block");
		 
 	 
  var windowHeightSeventyPercent = parseInt(screen.height * 0.7);

 $(".share_result_error").css("display","block");
 	 
				//	  $("img.loading").css("display","block"); 		    
 
	$('.progress').progress({value: 0 , color:'#00aeef', height: '5px'});
   
	//Menu screen button controls 
	$(".new-game").bind('touchend', function () {				 //On  s of New Game button of menu screen
			$(".new-game_btn").attr("src","images/end.png");
			$('.progress').progress({value: 0 , color:'#00aeef', height: '5px'});
			$(".screen-1").css("display","none");
			$(".screen-2").css("display","block");
			$(".screen-3").css("display","none");
	 
		   play_startup();
           // active=false;
		//	handler = false;
			
		    init();	
	});
 
//Game screen button controlss
 $(".new-game2").bind('touchend', function (e) { //On  touchend of New Game button of Game screen
 		     
		$(".screen-1").css("display","none");
		$(".screen-2").css("display","block");
		$(".screen-3").css("display","none");
		
		$('.progress').progress({value: 0 , color:'#00aeef', height: '5px'});		

	   
	    if( $('.share').css("display") == 'block' )  //Hide share popup
	 		$('.share').popup();
	    if( $('.caution').css("display") == 'block' )  //Hide caution popup
	        $('.caution').popup();	
	    
		time_count = 0;
		game_end_flag = 1;	

	   
		if( active == true){
			active=false;
			incorrectSequence();
			return false;
		}
          
        $(".new-game_btn").attr("src","images/end.png");
        
		if(start_flag == 1 && ( $(".popup.caution").css("display") == "none" )) { 
		    
			start_flag = 0;
			 
            incorrectSequence();
			return false;
	    } 
	 
	  if($(".popup.caution").css("display") == "none" )  	  {
	        play_startup();
	  	    init();
	  }
	   			
	});
   
    $(".aid").bind('touchend', function () { //Help pop up show
	    if( $('.caution').css("display") == 'block' )  //Hide caution popup
			$('.caution').popup();
		
		if( $('.share').css("display") == 'block' )  //Hide share popup
			$('.share').popup();	
		 
		    $('.helper').popup();
    });
 
    $(".aidok").bind('touchend', function () { //Help pop up close
		$('.helper').popup();
    });
    
    $(".ok_btn_img").bind('touchend', function () { //Caution pop up close
       	$('.caution').popup();
       	if(	$('.caution .title .endmsg').length){  //Show share score popup.
       		 	if( score > 0 ){
				  $(".share_title").html("Votre score : "+score);
				  
				  //display name and email from local storage.
				  if(  window.localStorage.getItem("fname") ){
				    fn =  window.localStorage.getItem("fname"); 
				    em =  window.localStorage.getItem("email"); 
					$("#full_name_box").val(fn);
				    $("#contact_box").val(em);
				  }
				  $(".share").popup();	
			    } 
			    else{
			    	location.reload(); 
			    	
			    }
       	}

    });
           
	$(".share-btn").bind('touchend', function () {  //Share score Cancel.

		$(".share_result_error").html(" ");  // Clear messages/errors
 
	    if( $('.share').css("display") == 'block')
	       $(".share").popup();  
	       location.reload();
	       
	  //tout = setTimeout( function() {
		 // clearTimeout(tout);
	  //  }, 500);
     
	});
 
    
	 //On touchend of BCV share button 
   	$(".s-btn").bind('touchend', function () {
	
		var submitdata = "";
		var fname = $.trim($("#full_name_box").val());
		// var cno = $.trim($("#contact_box").val());
		var email = $.trim($("#contact_box").val());
	    var regex_num = /[0-9\b]/; 
		var regex_email = /^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/i ;
		var reqexp_symb = /[-!$%^&*()_+|~=`{}\[\]:";'<>?,.\/]/;
		
	   $("#full_name_box").focus();
	   /* Validation */
	   if( fname == "" || regex_num.test(fname) || reqexp_symb.test(fname) ){
		   $(".share_result_error").html("Le nom est invalide");
	   }
	   else
	   if( email == "" || !regex_email.test(email) ){
			    $(".share_result_error").html("L’adresse e-mail n’est pas valable");
			 
	   }
	   else { 										//Call to web service for submitting : score, name, contact number. 
		$(".ld_div").css("display","block");
	    	$(".share_result_error").html(" ");
	        submitdata =  '{"Type_ID":"1","First_Name":"'+fname+'","Email":"'+email+'","Score":"'+score+'"}';  
           //update data in local storage : 
		   window.localStorage.setItem("fname", fname);
		   window.localStorage.setItem("email", email);
		   
		    $.ajax({			   				
						type: "POST",
						dataType: "text",
						timeout: 3000, // sets timeout to 3 seconds
						async:true,
						crossDomain:true,				
						url : "http://182.71.241.227:54321/Website-BCV/BCVServices.asmx/Add_Scores",	 
						data: "strJsonRequest="+submitdata,						
						success: function (data) {							
					          $(".ld_div").css("display","none");		    
							    $(".share_result_error").html("Soumis avec succ&egrave;s.!"); 
 
							    setTimeout( function() {
							     if( $('.share').css("display") == 'block')  //Hide share popup
								    $(".share").popup(); 
									location.reload(); 
								 }, 400);   
										
					    },
						
					    error: function (data, textStatus, errorThrown) {
					     $(".ld_div").css("display","none");
     						$(".share_result_error").html("Désolé, l’envoi a échoué.");
     						 //$("#full_name_box").focus();
 				 
					    }
 		
				});   
	   }
   });
 

/* Display Best Scores by retrieving Data from Web service */
 $(".best-score").bind("touchend", function () {
	   
        $(".ld_div").css("display","block");
	    $(".screen-1").css("display","none");
		$(".screen-2").css("display","none");
		$(".screen-3").css("display","block");
		
		if( $('.share').css("display") == 'block' )  //Hide share popup
		$('.share').popup();
		
		if( $('.caution').css("display") == 'block' )  //Hide caution popup
		$('.caution').popup();
			
		if( active == true) {
	      	incorrectSequence(); //Terminate game if user landed on best score screen	
		}
 		 
	        $.ajax({			   				
						type: 'POST',
		                timeout: 3000,  // sets timeout to 3 seconds						
						url : "http://182.71.241.227:54321/Website-BCV/BCVServices.asmx/Get_Best_Scores",		
					    dataType: "text",
						async:true,
						crossDomain:true,			
						data: "strJsonRequest="+scoredata,		
						success: function (xml) {					
					   $(".ld_div").css("display","none");					
				      
						// Parse the xml file and get data
						var xmlDoc = $.parseXML(xml),
						$xml = $(xmlDoc);
						$xml.find('string').each( function () {
							json_data = $.parseJSON(  $(this).text() );
						});
					 
						for(var i=0; i<= json_data["Table"].length; ++i) {
						 
							prank = json_data["Table"][i]["Rank"];			
							pname =   json_data["Table"][i]["Name"] ;
							pscore = json_data["Table"][i]["Score"] ;

							$(".trow"+i).find(".rank").text(prank);
							$(".trow"+i).find(".name").text(pname);
							$(".trow"+i).find(".score").text(pscore);
						  
						 }
				
					},
						
					error: function (data, textStatus, errorThrown) {
						       $(".ld_div").css("display","none");
	 
							   $(".caution .title").html("D&eacute;sol&eacute;, impossible de r&eacute;cup&eacute;rer des donn&eacute;es !");   //Popup message: "Sorry, Unable to get data !"
							   $(".caution").css("cssText", "height: 20% !important;");


							    if(width>height) {
							   		$(".caution .title").css("cssText", "font-size: 0.68em !important;");
							    	$(".caution .title").css("cssText", "margin: 25px 0 !important;");
							    }
							//   if((width>height) && ((navigator.platform.indexOf("iPhone") != -1)) ) {
							// 	$('.caution .title').css('cssText', 'margin: 30px 0 6px !important');
							// }
							   $(".caution").popup();  
							   
						} 
		
				});

	
});

//Best score page controls.
   $(".return-img").bind('touchend', function () {    // When return to game page from best score page 
		
			$(".screen-1").css("display","block");
			$(".screen-2").css("display","none");
			$(".screen-3").css("display","none");
			
 		    if( $('.caution').css("display") == 'block' )  //Hide caution popup
			      $('.caution').popup();
   });
   
   $("#full_name_box").focusin(function(){
   	$("body").height($("body").height()+parseInt(windowHeightSeventyPercent));
   });
   
   $("#full_name_box").focusout(function(){
   	$("body").height($("body").height()-parseInt(windowHeightSeventyPercent));
   });
   
   $("#contact_box").focusin(function(){
   	$("body").height($("body").height()+parseInt(windowHeightSeventyPercent));
   });
   
   $("#contact_box").focusout(function(){
   		$("body").height($("body").height()-parseInt(windowHeightSeventyPercent));
   });
 	 
	 
});
 
 